<template>
  <div class="relative bg-secondary-100">
    <section v-if="order" class="py-16">
      <div class="container mx-auto">
        <div class="overflow-hidden bg-white shadow sm:rounded-lg">
          <div class="relative px-4 py-5 sm:px-6">
            <span
              class="inline-block px-2 py-1 mb-3 text-xs font-semibold text-white rounded bg-primary-300"
            >
              {{ order.status }}
            </span>
            <h3 class="text-lg font-medium leading-6 text-gray-900">
              Order #{{ this.$route.params.id }}
            </h3>
            <p class="max-w-2xl mt-1 text-sm text-gray-500">
              <span class="mr-2 font-semibold text-black">Transaction ID:</span>
              {{ order.transactionId }}
            </p>
          </div>
          <div class="px-4 py-5 border-t border-gray-200 sm:px-6">
            <dl class="grid grid-cols-1 gap-x-4 gap-y-8 sm:grid-cols-2">
              <div class="sm:col-span-1">
                <dt class="text-sm font-semibold text-black">
                  Date created & completed
                </dt>
                <dd class="mt-1 text-sm text-gray-900">
                  {{ order.dateCompleted }}
                </dd>
              </div>

              <div class="sm:col-span-1">
                <dt class="text-sm font-semibold text-black">Date paid</dt>
                <dd class="mt-1 text-sm text-gray-900">
                  {{ order.datePaid }}
                </dd>
              </div>

              <div class="sm:col-span-1">
                <dt class="text-sm font-semibold text-black">Customer IP:</dt>
                <dd class="mt-1 text-sm text-gray-900">
                  {{ order.customerIpAddress }} <br />
                </dd>
              </div>

              <div class="sm:col-span-1">
                <dt class="text-sm font-semibold text-black">User agent</dt>
                <dd class="mt-1 text-sm text-gray-900">
                  {{ order.customerUserAgent }}
                </dd>
              </div>

              <div class="sm:col-span-1">
                <dt class="text-sm font-semibold text-black">Billing</dt>
                <dd class="mt-1 text-sm text-gray-900">
                  <p>
                    {{ order.billing.firstName }} {{ order.billing.lastName }}
                    <br />
                    {{ order.billing.address1 }} <br />
                    {{ order.billing.address2 }} <br />
                    {{ order.billing.city }}, {{ order.billing.state }} <br />
                    {{ order.billing.postcode }} {{ order.billing.country }}
                  </p>
                </dd>
              </div>

              <div class="sm:col-span-1">
                <dt class="text-sm font-semibold text-black">Shipping</dt>
                <dd class="mt-1 text-sm text-gray-900">
                  <a
                    :href="order.shippingAddressMapUrl"
                    target="_blank"
                    class="hover:text-primary-300"
                  >
                    <p>
                      {{ order.shipping.firstName }}
                      {{ order.shipping.lastName }}
                      <br />
                      {{ order.shipping.address1 }} <br />
                      {{ order.shipping.address2 }} <br />
                      {{ order.shipping.city }}, {{ order.shipping.state }}
                      <br />
                      {{ order.shipping.postcode }} {{ order.shipping.country }}
                    </p>
                  </a>
                </dd>
              </div>

              <div class="sm:col-span-1">
                <dt class="text-sm font-semibold text-black">Email address</dt>
                <dd class="mt-1 text-sm text-gray-900">
                  <a
                    :href="`mailto:${order.billing.email}`"
                    class="hover:text-primary-300"
                  >
                    {{ order.billing.email }}
                  </a>
                </dd>
              </div>

              <div class="sm:col-span-1">
                <dt class="text-sm font-semibold text-black">Phone number</dt>
                <dd class="mt-1 text-sm text-gray-900">
                  <a
                    :href="`tel:${order.billing.phone}`"
                    class="hover:text-primary-300"
                  >
                    {{ order.billing.phone }}
                  </a>
                </dd>
              </div>

              <div class="sm:col-span-2">
                <!-- <dt class="text-sm font-semibold text-black">Cart</dt> -->
                <dd class="mt-1 text-sm text-gray-900">
                  <ul>
                    <!-- Heading -->
                    <li class="grid grid-cols-5">
                      <div class="col-span-5 md:col-span-2">
                        <h3
                          class="text-sm font-medium text-center md:text-left text-secondary-300"
                        >
                          Product details
                        </h3>
                      </div>
                      <div class="col-span-5 text-center md:col-span-1">
                        <h3 class="text-sm font-medium text-secondary-300">
                          Quantity
                        </h3>
                      </div>
                      <div class="col-span-5 text-center md:col-span-1">
                        <h3 class="text-sm font-medium text-secondary-300">
                          Subtotal
                        </h3>
                      </div>
                      <div class="col-span-5 text-center md:col-span-1">
                        <h3 class="text-sm font-medium text-secondary-300">
                          Total
                        </h3>
                      </div>
                    </li>

                    <!-- Content -->
                    <client-only>
                      <li
                        v-for="(lineItem, index) in order.lineItems.nodes"
                        :key="index"
                        class="grid grid-cols-5 py-2 pl-2 border-b hover:bg-secondary-100 hover:shadow-sm border-secondary-100"
                      >
                        <div class="col-span-5 md:col-span-2">
                          <div
                            class="flex items-center justify-center md:justify-start"
                          >
                            <div class="bg-secondary-200">
                              <div
                                class="block border border-white shadow-md hover:border-primary-200"
                              >
                                <img
                                  v-lazy="lineItem.product.productImages.image"
                                  class="object-contain object-center h-20"
                                  :alt="lineItem.product.name"
                                />
                              </div>
                            </div>
                            <div class="ml-5">
                              <span
                                class="mb-2 text-sm text-secondary-300 hover:text-primary-300"
                              >
                                <h3 title="Product name">
                                  {{
                                    lineItem.product.name
                                      .split(' - ')[1]
                                      .replace(/--/g, '')
                                      .replace(/_/g, ' ')
                                  }}
                                </h3>
                              </span>
                              <span
                                class="block mb-1 text-base font-semibold"
                                title="Brand"
                              >
                                {{ lineItem.product.name.split(' - ')[0] }}
                              </span>
                              <span
                                v-if="lineItem.product.type === 'VARIABLE'"
                                class="block mb-3 text-xs"
                              >
                                <span class="capitalize">
                                  {{
                                    lineItem.variation.attributes.nodes[0].name.split(
                                      'pa_'
                                    )[1]
                                  }}
                                </span>
                                {{
                                  lineItem.variation.attributes.nodes[0].value
                                }}
                              </span>
                            </div>
                          </div>
                        </div>

                        <div
                          class="flex items-center justify-center col-span-5 md:col-span-1"
                        >
                          <span>
                            {{ lineItem.quantity }}
                          </span>
                        </div>

                        <div
                          class="flex items-center justify-center col-span-5 md:col-span-1"
                        >
                          <h3 class="text-base font-semibold" title="Price">
                            US$ {{ getPriceRounded(lineItem.subtotal) }}
                          </h3>
                        </div>

                        <div
                          class="flex items-center justify-center col-span-5 md:col-span-1"
                        >
                          <span>US$ {{ getPriceRounded(lineItem.total) }}</span>
                        </div>
                      </li>
                    </client-only>

                    <!-- Resumen -->
                    <li class="flex items-center justify-end">
                      <div class="w-full mt-10 text-right md:w-1/3">
                        <div class="flex items-center justify-between px-3">
                          <span class="mr-2 font-semibold text-secondary-300">
                            Subtotal:
                          </span>
                          <span>US{{ order.subtotal }}</span>
                        </div>

                        <div
                          class="flex items-center justify-between px-3 mt-3"
                        >
                          <span class="mr-2 font-semibold text-secondary-300">
                            Discount:
                          </span>
                          <span>US{{ order.discountTotal }}</span>
                        </div>

                        <div
                          class="flex items-center justify-between px-3 mt-3"
                        >
                          <span class="mr-2 font-semibold text-secondary-300">
                            Shipping:
                          </span>
                          <span>US{{ order.shippingTotal }}</span>
                        </div>

                        <div
                          class="flex items-center justify-between px-3 py-3 mt-3 font-semibold uppercase border-t bg-secondary-100 border-secondary-300"
                        >
                          <span class="mr-2 font-semibold text-black">
                            Total:
                          </span>
                          <span>US{{ order.total }}</span>
                        </div>
                      </div>
                    </li>
                  </ul>
                </dd>
              </div>
            </dl>
          </div>
        </div>
      </div>
    </section>
  </div>
</template>

<script>
import getOrder from '~/apollo/queries/orders/getOrder.gql'

export default {
  layout: 'customer',
  data() {
    return {}
  },
  apollo: {
    order: {
      prefetch: true,
      query: getOrder,
      variables() {
        return {
          id: this.$route.params.id,
        }
      },
      update(data) {
        // console.log(data)
        return data.order
      },
    },
  },
  methods: {
    getPriceRounded(price) {
      return Math.round((parseFloat(price) + Number.EPSILON) * 100) / 100
    },
  },
}
</script>
